package ru.dbotthepony.kstarbound.defs.item

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.defs.IThingWithDescription
import ru.dbotthepony.kstarbound.defs.ThingDescription
import ru.dbotthepony.kvector.vector.Color
import ru.dbotthepony.kvector.vector.ndouble.Vector2d

data class FlashlightDefinition(
	override val itemName: String,
	override val price: Long,
	override val rarity: ItemRarity,
	override val category: String?,
	override val inventoryIcon: ImmutableList<out IItemDefinition.IInventoryIcon>?,
	override val itemTags: ImmutableList<String>,
	override val learnBlueprintsOnPickup: ImmutableList<String>,
	override val maxStack: Long,
	override val eventCategory: String?,
	override val consumeOnPickup: Boolean,
	override val pickupQuestTemplates: ImmutableList<String>,
	override val tooltipKind: ItemTooltipKind,
	override val twoHanded: Boolean,
	override val radioMessagesOnPickup: ImmutableList<String>,
	override val fuelAmount: Long?,

	override val lightPosition: Vector2d,
	override val lightColor: Color,
	override val beamLevel: Int,
	override val beamAmbience: Double,
	override val handPosition: Vector2d,

	val descriptionData: ThingDescription,

	val json: Map<String, Any>
) : IFlashlightDefinition, IThingWithDescription by descriptionData
