package ru.dbotthepony.kstarbound.defs.item

import ru.dbotthepony.kstarbound.defs.util.enrollMap
import ru.dbotthepony.kstarbound.io.json.builder.JsonBuilder
import ru.dbotthepony.kstarbound.util.NotNullVar
import ru.dbotthepony.kvector.vector.Color
import ru.dbotthepony.kvector.vector.ndouble.Vector2d

@JsonBuilder
class FlashlightPrototype : ItemPrototype(), IFlashlightDefinition {
	override var lightPosition: Vector2d by NotNullVar()
	override var lightColor: Color by NotNullVar()
	override var beamLevel: Int by NotNullVar()
	override var beamAmbience: Double by NotNullVar()
	override var handPosition: Vector2d by NotNullVar()

	init {
		maxStack = 1L
	}

	override fun assemble(): IItemDefinition {
		return FlashlightDefinition(
			descriptionData = descriptionData,
			itemName = itemName,
			price = price,
			rarity = rarity,
			category = category,
			inventoryIcon = inventoryIcon,
			itemTags = itemTags,
			learnBlueprintsOnPickup = learnBlueprintsOnPickup,
			maxStack = maxStack,
			eventCategory = eventCategory,
			consumeOnPickup = consumeOnPickup,
			pickupQuestTemplates = pickupQuestTemplates,
			tooltipKind = tooltipKind,
			twoHanded = twoHanded,
			radioMessagesOnPickup = radioMessagesOnPickup,
			fuelAmount = fuelAmount,

			json = enrollMap(json),

			lightPosition = lightPosition,
			lightColor = lightColor,
			beamLevel = beamLevel,
			beamAmbience = beamAmbience,
			handPosition = handPosition,
		)
	}
}
