package ru.dbotthepony.kstarbound.defs.tile

import com.google.gson.GsonBuilder
import ru.dbotthepony.kstarbound.Starbound
import ru.dbotthepony.kstarbound.io.json.builder.FactoryAdapter
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory

const val TILE_COLOR_VARIANTS = 9

@JsonFactory
data class RenderParameters(
	val texture: String,
	val variants: Int = 0,
	val multiColored: Boolean = false,
	val occludesBelow: Boolean = false,
	val lightTransparent: Boolean = false,
	val zLevel: Int,
) {
	val absoluteTexturePath: String

	init {
		val dir = Starbound.assetFolder

		if (dir == null || texture[0] == '/') {
			absoluteTexturePath = texture
		} else {
			absoluteTexturePath = "$dir/$texture"
		}
	}
}
