package ru.dbotthepony.kstarbound.defs.tile

import com.google.gson.GsonBuilder
import ru.dbotthepony.kstarbound.io.json.builder.FactoryAdapter
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.registerTypeAdapter
import ru.dbotthepony.kvector.vector.Color

@JsonFactory
data class TileDefinition(
	val materialId: Int,
	val materialName: String,
	val particleColor: Color? = null,
	val itemDrop: String? = null,
	val description: String = "...",
	val shortdescription: String = "...",
	val footstepSound: String? = null,

	val blocksLiquidFlow: Boolean = true,
	val soil: Boolean = false,

	val health: Double = 0.0,
	val category: String,

	override val renderTemplate: RenderTemplate,
	override val renderParameters: RenderParameters,
) : IRenderableTile
